/**
* @file SelectionSort.java
*
* @brief This file contains the sorting.SelectionSort class.
*
* @author Philipp Bank, www.cypax.net\n
*
* @date June, 19th 2006 - first version
*
**/

package sorting;

import java.awt.*;

/**
* @class SelectionSort
* @brief The SelectionSort class extends the Sort class and sorts arrays with the selectionsort algorithm.
*
* The used selectionsort code is adapted from <a href="http://de.wikipedia.org/wiki/Selectionsort">http://de.wikipedia.org/wiki/Selectionsort</a>.
*/
public class SelectionSort extends Sort
{

/**
* @brief This is the sorting algorithm.
*
* The used selectionsort code is adapted from <a href="http://de.wikipedia.org/wiki/Selectionsort">http://de.wikipedia.org/wiki/Selectionsort</a>.
*/
  protected void doSort()
  {
    for (int index=0; index<theArray.length-1; index++)
    {
      int minIdx = minimum(theArray, index, theArray.length-1);
      this.exchange(theArray, index, minIdx);
      this.showArray();
      this.theLabel.setText(this.calcRuntime()+"ms");
      this.theLabel.validate();
    }
  }

/**
* @brief This function is used to locate the minimum value in a array of integers.
*/
  private int minimum(int[] array, int anfang, int ende)
  {
    int minIdx = anfang;
    for (int index=anfang+1; index<=ende; index++)
    {
      if (array[index] < array[minIdx])
      {
        minIdx = index;
      }
    }
    return minIdx;
  }

}
